// TRAINMOD events //

// INPUTS
registerInputEvent("fxDTSBrick", "onTrainDetected", "Self fxDTSBrick" TAB "Train Player" TAB "MiniGame MiniGame", 0);

// OUTPUTS
registerOutputEvent("Player", "TrainMode", "list Neutral 0 Forward 1 Reverse 2 Brake 3 SoundHorn 1337", 0);
registerOutputEvent("fxDTSBrick", "TrainMode", "list Neutral 0 Forward 1 Reverse 2 Brake 3 SoundHorn 1337", 0);
registerOutputEvent("Player", "setTrainLocked", "bool", 0);
registerOutputEvent("fxDTSBrick", "setTrainLocked", "bool", 0);

// FUNCTIONS
function Player::TrainMode(%this,%arg) {
    if(%this.isTrain != 1) {
        return;
    }
    
    // horn
    if(%arg == 1337) {
        if(%this.hornsound !$= 0) {
            serverPlay3D(%this.hornsound,%this.getposition());
        }
        return;
    }
    
    // engine
    if(%arg == 0) {
        %this.enginestatus = 0;
        if(%this.playenginesound >= 1) {
            %this.playenginesound = -1;
        }
    }
    
    if(%arg == 1) {
        if(%this.hasengine == 1) {
            %this.enginestatus = 1;
            if(%this.playenginesound <= 0) {
                %this.playenginesound = 1;
            }
            %this.lastrotbrick = 0;
        }
    }
    
    if(%arg == 2) {
        if(%this.hasengine == 1) {
            %this.enginestatus = 2;
            %this.lastrotbrick = 0;
            if(%this.playenginesound <= 0) {
                %this.playenginesound = 1;
            }
        }
    }
    
    if(%arg == 3) {
        if(%this.hasbrakes == 1 && $Pref::Trains::Brakes == 1) {
            %this.enginestatus = 3;
            if(%this.playenginesound >= 1) {
                %this.playenginesound = 0;
            }
        }
    }
}

function fxDTSBrick::TrainMode(%brick,%arg) {
    
    %this = %brick.vehicle;
    
    if(!isObject(%this)) {
        return;
    }
    
    if(%this.isTrain != 1) {
        return;
    }
    
    // horn
    if(%arg == 1337) {
        if(%this.hornsound !$= 0) {
            serverPlay3D(%this.hornsound,%this.getposition());
        }
        return;
    }
    
    // engine
    if(%arg == 0) {
        %this.enginestatus = 0;
        if(%this.playenginesound >= 1) {
            %this.playenginesound = -1;
        }
    }
    
    if(%arg == 1) {
        if(%this.hasengine == 1) {
            %this.enginestatus = 1;
            if(%this.playenginesound <= 0) {
                %this.playenginesound = 1;
            }
            %this.lastrotbrick = 0;
        }
    }
    
    if(%arg == 2) {
        if(%this.hasengine == 1) {
            %this.enginestatus = 2;
            %this.lastrotbrick = 0;
            if(%this.playenginesound <= 0) {
                %this.playenginesound = 1;
            }
        }
    }
    
    if(%arg == 3) {
        if(%this.hasbrakes == 1 && $Pref::Trains::Brakes == 1) {
            %this.enginestatus = 3;
            if(%this.playenginesound >= 1) {
                %this.playenginesound = 0;
            }
        }
    }
}

function AIPlayer::setTrainLocked(%this,%arg)
{
    %this.trainLocked = %arg;
}

function fxDTSBrick::setTrainLocked(%brick,%arg)
{
    %this = %brick.vehicle;
    
    if(!isObject(%this)) {
        return;
    }
    
    %this.trainLocked = %arg;
}